*LCC MODEL

sets
i                work-brakedown structure                /Start, End/
subi1(i)         all R&D processes
subi2(i)         all manufacturing processes
subi3(i)         all usage processes
subi4(i)         all EOL processes
;
alias (i,j);



parameters
* Parameters
balance(i)             parameter to secure that a product will not stuck at an activity j
capacity(i,j)          max amount of products for activity j
time(j)                time of occurrence for activity j

************************** PHASE: Research & Development *********************************************************************
******* VARIABLE COST TYPES **************************************************************************************************
c_RD_v1(j)           variable cost type 1 for activity j in phase "Research & Development"
c_RD_v2(j)           variable cost type 2 for activity j in phase "Research & Development"
c_RD_v3(j)           variable cost type 3 for activity j in phase "Research & Development"
c_RD_v4(j)           variable cost type 4 for activity j in phase "Research & Development"
c_RD_v5(j)           variable cost type 5 for activity j in phase "Research & Development"
c_RD_v6(j)           variable cost type 6 for activity j in phase "Research & Development"

******* NON-RECURRING / ONE-TIME COST TYPES **********************************************************************************
c_RD_NR1(j)           non-recurring one-time cost type 1 for activity j in phase "Research & Development"
c_RD_NR2(j)           non-recurring one-time cost type 2 for activity j in phase "Research & Development"
c_RD_NR3(j)           non-recurring one-time cost type 3 for activity j in phase "Research & Development"
c_RD_NR4(j)           non-recurring one-time cost type 4 for activity j in phase "Research & Development"
c_RD_NR5(j)           non-recurring one-time cost type 5 for activity j in phase "Research & Development"
c_RD_NR6(j)           non-recurring one-time cost type 6 for activity j in phase "Research & Development"


************************** PHASE: MANUFACTURING *********************************************************************
******* VARIABLE COST TYPES **************************************************************************************************
c_M_v1(j)           variable cost type 1 for activity j in phase "Manufacturing"
c_M_v2(j)           variable cost type 2 for activity j in phase "Manufacturing"
c_M_v3(j)           variable cost type 3 for activity j in phase "Manufacturing"
c_M_v4(j)           variable cost type 4 for activity j in phase "Manufacturing"
c_M_v5(j)           variable cost type 5 for activity j in phase "Manufacturing"
c_M_v6(j)           variable cost type 6 for activity j in phase "Manufacturing"
******* NON-RECURRING / ONE-TIME COST TYPES **********************************************************************************
c_M_NR1(j)           non-recurring one-time cost type 1 for activity j in phase "Manufacturing"
c_M_NR2(j)           non-recurring one-time cost type 2 for activity j in phase "Manufacturing"
c_M_NR3(j)           non-recurring one-time cost type 3 for activity j in phase "Manufacturing"
c_M_NR4(j)           non-recurring one-time cost type 4 for activity j in phase "Manufacturing"
c_M_NR5(j)           non-recurring one-time cost type 5 for activity j in phase "Manufacturing"
c_M_NR6(j)           non-recurring one-time cost type 6 for activity j in phase "Manufacturing"


************************** PHASE: USAGE *********************************************************************
******* VARIABLE COST TYPES **************************************************************************************************
c_U_v1(j)           variable cost type 1 for activity j in phase "Usage"
c_U_v2(j)           variable cost type 2 for activity j in phase "Usage"
c_U_v3(j)           variable cost type 3 for activity j in phase "Usage"
c_U_v4(j)           variable cost type 4 for activity j in phase "Usage"
c_U_v5(j)           variable cost type 5 for activity j in phase "Usage"
c_U_v6(j)           variable cost type 6 for activity j in phase "Usage"
******* NON-RECURRING / ONE-TIME COST TYPES ************************************************************************************
c_U_NR1(j)           non-recurring one-time cost type 1 for activity j in phase "Usage"
c_U_NR2(j)           non-recurring one-time cost type 2 for activity j in phase "Usage"
c_U_NR3(j)           non-recurring one-time cost type 3 for activity j in phase "Usage"
c_U_NR4(j)           non-recurring one-time cost type 4 for activity j in phase "Usage"
c_U_NR5(j)           non-recurring one-time cost type 5 for activity j in phase "Usage"
c_U_NR6(j)           non-recurring one-time cost type 6 for activity j in phase "Usage"


************************** PHASE: END-OF-LIFE *********************************************************************
******* VARIABLE COST TYPES **************************************************************************************************
c_E_v1(j)           variable cost type 1 for activity j in phase "End-of-Life"
c_E_v2(j)           variable cost type 2 for activity j in phase "End-of-Life"
c_E_v3(j)           variable cost type 3 for activity j in phase "End-of-Life"
c_E_v4(j)           variable cost type 4 for activity j in phase "End-of-Life"
c_E_v5(j)           variable cost type 5 for activity j in phase "End-of-Life"
c_E_v6(j)           variable cost type 6 for activity j in phase "End-of-Life"
******* NON-RECURRING / ONE-TIME COST TYPES ******************************************************************************************************
c_E_NR1(j)           non-recurring one-time cost type 1 for activity j in phase "End-of-Life"
c_E_NR2(j)           non-recurring one-time cost type 2 for activity j in phase "End-of-Life"
c_E_NR3(j)           non-recurring one-time cost type 3 for activity j in phase "End-of-Life"
c_E_NR4(j)           non-recurring one-time cost type 4 for activity j in phase "End-of-Life"
c_E_NR5(j)           non-recurring one-time cost type 5 for activity j in phase "End-of-Life"
c_E_NR6(j)           non-recurring one-time cost type 6 for activity j in phase "End-of-Life"
;
*************************************************************************************************************************
*************************************************************************************************************************
*************************************************************************************************************************


balance(i) = 0;
balance("Start") = 1;
balance("End") = -1;

scalar
lotsize
r
;
r = 0.1;
lotsize = 200;




*Loading data from Excel'
$Call 'gdxxrw.exe i=RunTest_2D_1.XLS cmerge=1 se=0 o=LCCModel.gdx UpdLinks=3 index=GamsInput!B4'
$gdxin LCCModel.gdx

$loadM i<subi1.dim1
$loadM i<subi2.dim1
$loadM i<subi3.dim1
$loadM i<subi4.dim1

$load subi1
$load subi2
$load subi3
$load subi4

$load capacity
$load time

$load c_RD_v1
$load c_RD_v2
$load c_RD_v3
$load c_RD_v4
$load c_RD_v5
$load c_RD_v6
$load c_RD_NR1
$load c_RD_NR2
$load c_RD_NR3
$load c_RD_NR4
$load c_RD_NR5
$load c_RD_NR6

$load c_M_v1
$load c_M_v2
$load c_M_v3
$load c_M_v4
$load c_M_v5
$load c_M_v6
$load c_M_NR1
$load c_M_NR2
$load c_M_NR3
$load c_M_NR4
$load c_M_NR5
$load c_M_NR6

$load c_U_v1
$load c_U_v2
$load c_U_v3
$load c_U_v4
$load c_U_v5
$load c_U_v6
$load c_U_NR1
$load c_U_NR2
$load c_U_NR3
$load c_U_NR4
$load c_U_NR5
$load c_U_NR6

$load c_E_v1
$load c_E_v2
$load c_E_v3
$load c_E_v4
$load c_E_v5
$load c_E_v6
$load c_E_NR1
$load c_E_NR2
$load c_E_NR3
$load c_E_NR4
$load c_E_NR5
$load c_E_NR6

$gdxin
;

balance(i) = lotsize * balance(i);
capacity(i,j) = lotsize * capacity(i,j)


positive variables
* Variables (positive)
f(i,j)          flow from activity i to j
;

variables
* Objective variable to find minimum LCC
z               LCC
;

********************************************************************************************************************
************** EQUATIONS *******************************************************************************************
********************************************************************************************************************
equations
* Equations to solve model for each alternative described in EXCEL
equa_cap(i,j)      capacity constraint for an edge from activity i to j for each alternative
equa_bal(i)        balance constraint to ensure that a product goes through the whole life-cycle
equa_objective     objective function to minimize the life-cycle costs for each alternative
;

equa_cap(i,j)..
f(i,j) =l= capacity(i,j);

equa_bal(i)..
sum(j, f(i,j)) - sum(j, f(j,i)) =e= balance(i);

equa_objective..
z =e= sum((i,j),
(1/((1+r)**(time(j)))) *
(f(i,j)*(c_RD_v1(j) + c_RD_v2(j) + c_RD_v3(j) + c_RD_v4(j) + c_RD_v5(j) + c_RD_v6(j)) +
(f(i,j)/(lotsize**2))*(c_RD_NR1(j) + c_RD_NR2(j) + c_RD_NR3(j) + c_RD_NR4(j) + c_RD_NR5(j) + c_RD_NR6(j)) +

f(i,j)*(c_M_v1(j) + c_M_v2(j) + c_M_v3(j) + c_M_v4(j) + c_M_v5(j) + c_M_v6(j)) +
(f(i,j)/(lotsize**2))*(c_M_NR1(j) + c_M_NR2(j) + c_M_NR3(j) + c_M_NR4(j) + c_M_NR5(j) + c_M_NR6(j)) +

f(i,j)*(c_U_v1(j) + c_U_v2(j) + c_U_v3(j) + c_U_v4(j) + c_U_v5(j) + c_U_v6(j)) +
(f(i,j)/(lotsize**2))*(c_U_NR1(j) + c_U_NR2(j) + c_U_NR3(j) + c_U_NR4(j) + c_U_NR5(j) + c_U_NR6(j)) +

f(i,j)*(c_E_v1(j) + c_E_v2(j) + c_E_v3(j) + c_E_v4(j) + c_E_v5(j) + c_E_v6(j)) +
(f(i,j)/(lotsize**2))*(c_E_NR1(j) + c_E_NR2(j) + c_E_NR3(j) + c_E_NR4(j) + c_E_NR5(j) + c_E_NR6(j)))
);



********************************************************************************************************************
************** SOLVE ***********************************************************************************************
********************************************************************************************************************

model LCC_MODEL /all/;

*with this option gams puts the results of this model into a file with the name LCC_MODEL_p.gdx
OPTION Savepoint = 1;

Option LP = Cplex;

solve LCC_MODEL minimizing z using LP;

display z.l, f.l;

execute_unload 'GAMSOutput.gdx';
execute 'GDXXRW.exe i=GAMSOutput.gdx o=RunTest_2D_1.XLS skipempty=0 index=GamsOutput!B4'

